#include "syscall.h"

/* Return ABI: $1 is errno, $0 is return value. */

#define S(n) \
	.global n ; .weak n ; n: ; \
	.2byte 0x7800 | ((SYS_##n & 0xe) << 7) | ((SYS_##n & 1) << 4) ; bra sysret

	.text

#define SYS___mep_write SYS_write
#define SYS___mep_read SYS_read
#define SYS__Sid_config SYS_reconfig

S(open)
S(close)
S(__mep_read)
S(__mep_write)
S(lseek)
S(unlink)
S(getpid)
S(kill)
S(fstat)

/* ARGV support.  */
S(argvlen)
S(argv)

/* These are extras added for one reason or another.  */
S(chdir)
S(stat)
S(chmod)
S(utime)
S(time)
S(gettimeofday)
S(times)
S(link)
S(_Sid_config)

sysret:
	add3	$sp, $sp, -12
	sw	$0, 0($sp)
	sw	$1, 4($sp)
	ldc	$2, $lp
	sw	$2, 8($sp)
	bsr	__errno
	lw	$1, 4($sp)
	sw	$1, ($0)
	lw	$0, 0($sp)
	lw	$2, 8($sp)
	stc	$2, $lp
	add3	$sp, $sp, 12
	ret
